Package net.sf.saxon.om

## Interface NodeInfo

- All Superinterfaces:
    `GroundedValue`, `Item`, `Location`, `org.xml.sax.Locator`, `Sequence`, `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`
  All Known Subinterfaces:
    `MutableNodeInfo`, `SiblingCountingNode`, `SteppingNode<N>`, `VirtualNode`
  All Known Implementing Classes:
    `AbsentExtensionElement`, `AbstractNodeWrapper`, `AbstractVirtualNode`, `AnnotationParent`, `AttributeImpl`, `AxiomAttributeWrapper`, `AxiomDocumentNodeWrapper`, `AxiomElementNodeWrapper`, `AxiomLeafNodeWrapper`, `AxiomParentNodeWrapper`, `CommentImpl`, `DataElement`, `DocumentImpl`, `DOM4JNodeWrapper`, `DominoAttr`, `DominoNode`, `DOMNodeWrapper`, `ElementImpl`, `ExtensionInstruction`, `FleetingDocumentNode`, `FleetingElementNode`, `FleetingNode`, `FleetingParentNode`, `IXSLRemoveAttribute`, `IXSLRemoveProperty`, `IXSLScheduleAction`, `IXSLSetAttribute`, `IXSLSetProperty`, `IXSLSetStyle`, `JDOM2NodeWrapper`, `LiteralResultElement`, `NamespaceNode`, `NodeImpl`, `Orphan`, `ParentNodeImpl`, `ProcInstImpl`, `RebasedNode`, `SaxonArray`, `SaxonArrayMemberInst`, `SaxonAssign`, `SaxonChange`, `SaxonDeepUpdate`, `SaxonDelete`, `SaxonDo`, `SaxonDoctype`, `SaxonEntityRef`, `SaxonForEachMember`, `SaxonImportQuery`, `SaxonInsert`, `SaxonItemType`, `SaxonParam`, `SaxonPreprocess`, `SaxonRename`, `SaxonReplace`, `SaxonTabulateMaps`, `SaxonUpdate`, `SaxonWhile`, `SchemaElement`, `SnapshotNode`, `SpaceStrippedNode`, `SQLClose`, `SQLColumn`, `SQLConnect`, `SQLDelete`, `SQLExecute`, `SQLInsert`, `SQLQuery`, `SQLUpdate`, `StyleElement`, `TextFragmentValue`, `TextImpl`, `TextValueTemplateNode`, `TinyAttributeImpl`, `TinyDocumentImpl`, `TinyElementImpl`, `TinyNodeImpl`, `TinyParentNodeImpl`, `TinyTextImpl`, `TinyTextualElement`, `TinyTextualElement.TinyTextualElementText`, `TypeStrippedNode`, `UnknownElement`, `VirtualCopy`, `VirtualUntypedCopy`, `WhitespaceTextImpl`, `XOMDocumentWrapper`, `XOMNodeWrapper`, `XSDAlternative`, `XSDAnnotation`, `XSDAny`, `XSDAnyAttribute`, `XSDAssert`, `XSDAttribute`, `XSDAttributeGroup`, `XSDComplexContent`, `XSDComplexContentRestriction`, `XSDComplexType`, `XSDCompositor`, `XSDDefaultOpenContent`, `XSDDocumentation`, `XSDElement`, `XSDExtension`, `XSDFacet`, `XSDFieldOrSelector`, `XSDGroup`, `XSDIdentityConstraint`, `XSDImport`, `XSDInclude`, `XSDList`, `XSDNotation`, `XSDOpenContent`, `XSDOverride`, `XSDRedefine`, `XSDSchema`, `XSDSimpleContent`, `XSDSimpleContentRestriction`, `XSDSimpleType`, `XSDSimpleTypeRestriction`, `XSDUnion`, `XSLAccept`, `XSLAcceptExpose`, `XSLAccumulator`, `XSLAccumulatorRule`, `XSLAnalyzeString`, `XSLApplyImports`, `XSLApplyTemplates`, `XSLAssert`, `XSLAttribute`, `XSLAttributeSet`, `XSLBreak`, `XSLBreakOrContinue`, `XSLCallTemplate`, `XSLCatch`, `XSLCharacterMap`, `XSLChoose`, `XSLComment`, `XSLContextItem`, `XSLCopy`, `XSLCopyOf`, `XSLDecimalFormat`, `XSLDocument`, `XSLElement`, `XSLEvaluate`, `XSLExpose`, `XSLFallback`, `XSLForEach`, `XSLForEachGroup`, `XSLFork`, `XSLFunction`, `XSLGeneralIncorporate`, `XSLGeneralVariable`, `XSLGlobalContextItem`, `XSLGlobalParam`, `XSLGlobalVariable`, `XSLIf`, `XSLImport`, `XSLImportSchema`, `XSLInclude`, `XSLIterate`, `XSLKey`, `XSLLeafNodeConstructor`, `XSLLocalParam`, `XSLLocalVariable`, `XSLMap`, `XSLMapEntry`, `XSLMatchingSubstring`, `XSLMerge`, `XSLMergeAction`, `XSLMergeKey`, `XSLMergeSource`, `XSLMessage`, `XSLMode`, `XSLModuleRoot`, `XSLNamespace`, `XSLNamespaceAlias`, `XSLNextIteration`, `XSLNextMatch`, `XSLNumber`, `XSLOnCompletion`, `XSLOnEmpty`, `XSLOnNonEmpty`, `XSLOtherwise`, `XSLOutput`, `XSLOutputCharacter`, `XSLOverride`, `XSLPackage`, `XSLPerformSort`, `XSLPreserveSpace`, `XSLProcessingInstruction`, `XSLResultDocument`, `XSLSequence`, `XSLSort`, `XSLSortOrMergeKey`, `XSLSourceDocument`, `XSLStylesheet`, `XSLTemplate`, `XSLText`, `XSLTry`, `XSLUsePackage`, `XSLValueOf`, `XSLWhen`, `XSLWherePopulated`, `XSLWithParam`

      public interface NodeInfo
      extends javax.xml.transform.Source, Item, Location

  The NodeInfo interface represents a node in Saxon's implementation of the XPath 2.0 data model.

  Note that several NodeInfo objects may represent the same node. To test node identity, the method `equals(Object)` should be used. An exception to this rule applies for document nodes, where the correspondence between document nodes and DocumentInfo objects is one to one. NodeInfo objects are never reused: a given NodeInfo object represents the same node for its entire lifetime.

  This is the primary interface for accessing trees in Saxon, and it forms part of the public Saxon API. Methods that form part of the public API are (since Saxon 8.4) labelled with a JavaDoc "since" tag: classes and methods that have no such label should not be regarded as stable interfaces.

  The interface represented by this class is at a slightly higher level than the abstraction described in the W3C data model specification, in that it includes support for the XPath axes, rather than exposing the lower-level properties (such as "parent" and "children") directly. All navigation within trees, except for a few convenience methods, is done by following the axes using the `iterateAxis(int)` method. This allows different implementations of the XPath tree model to implement axis navigation in different ways. Some implementations may choose to use the helper methods provided in class `Navigator`.

  Note that the stability of this interface applies to classes that use the interface, not to classes that implement it. The interface may be extended in future to add new methods.

  New implementations of NodeInfo are advised also to implement the methods in interface ExtendedNodeInfo, which will be moved into this interface at some time in the future.

  Since:
    8.4. Extended with three extra methods, previously in ExtendedNodeInfo, in 9.1. In 9.7, DocumentInfo is no longer defined as a sub-interface; it is replaced with TreeInfo, which contains information about any XML node tree, whether or not it is rooted at a document node. In 9.8, default implementations are provided for some of the methods, making it easier to create a new implementation of this interface.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `IS_DTD_TYPE` | Bit setting in the returned type annotation indicating a DTD_derived type on an attribute node
    `static int` | `IS_NILLED` | Bit setting for use alongside a type annotation indicating that the is-nilled property is set

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AtomicSequence` | `atomize()` | Get the typed value.
    `default AttributeMap` | `attributes()` |
    `default java.lang.Iterable<? extends NodeInfo>` | `children()` | Return the sequence of children of this node, as an `Iterable`.
    `default java.lang.Iterable<? extends NodeInfo>` | `children​(java.util.function.Predicate<? super NodeInfo> filter)` | Return the sequence of children of this node, filtered by a supplied predicate, as an `Iterable`.
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `default void` | `copy​(Receiver out, int copyOptions, Location locationId)` | Copy this node to a given Receiver.
    `boolean` | `equals​(java.lang.Object other)` | The equals() method compares nodes for identity.
    `void` | `generateId​(FastStringBuffer buffer)` | Construct a character string that uniquely identifies this node.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `java.lang.String` | `getBaseURI()` | Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `default int` | `getColumnNumber()` | Get column number.
    `default Configuration` | `getConfiguration()` | Convenience method to get the Configuration.
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace declarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node, in the form of a lexical QName.
    `int` | `getFingerprint()` | Get fingerprint.
    `default Genre` | `getGenre()` | Get the genre of this item
    `default int` | `getLineNumber()` | Get line number.
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `int` | `getNodeKind()` | Get the kind of node.
    `NodeInfo` | `getParent()` | Get the NodeInfo object representing the parent of this node
    `java.lang.String` | `getPrefix()` | Get the prefix of the name of the node.
    `default java.lang.String` | `getPublicId()` | Get the Public ID of the entity containing the node.
    `NodeInfo` | `getRoot()` | Get the root node of the tree containing this node
    `default SchemaType` | `getSchemaType()` | Get the type annotation of this node, if any.
    `java.lang.String` | `getStringValue()` | Return the string value of the node as defined in the XPath data model.
    `java.lang.String` | `getSystemId()` | Get the System ID for the node.
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool.
    `int` | `hashCode()` | The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `default boolean` | `isId()` | Ask whether this node has the is-id property
    `default boolean` | `isIdref()` | Ask whether this node has the is-idref property
    `default boolean` | `isNilled()` | Ask whether the node has the is-nilled property
    `default boolean` | `isSameNodeInfo​(NodeInfo other)` | Determine whether this is the same node as another node.
    `default boolean` | `isStreamed()` | Ask whether this is a node in a streamed document
    `default AxisIterator` | `iterateAxis​(int axisNumber)` | Return an iteration over all the nodes reached by the given axis from this node
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
    `default java.lang.String` | `toShortString()` | Provide a short string showing the contents of the item, suitable for use in error messages

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, getStringValueCS, head, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.s9api.Location

      `saveLocation`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty, setSystemId`

- - ### Field Detail

    - #### IS_DTD_TYPE

          static final int IS_DTD_TYPE

      Bit setting in the returned type annotation indicating a DTD_derived type on an attribute node
      See Also:
        Constant Field Values

    - #### IS_NILLED

          static final int IS_NILLED

      Bit setting for use alongside a type annotation indicating that the is-nilled property is set
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getTreeInfo

          TreeInfo getTreeInfo()

      Get information about the tree to which this NodeInfo belongs
      Returns:
        the TreeInfo
      Since:
        9.7

    - #### getConfiguration

          default Configuration getConfiguration()

      Convenience method to get the Configuration. Always returns the same result as `getTreeInfo().getConfiguration()`
      Returns:
        the Configuration to which the tree belongs. The default implementation invokes `getTreeInfo().getConfiguration()`.
      Since:
        8.4

    - #### getNodeKind

          int getNodeKind()

      Get the kind of node. This will be a value such as `Type.ELEMENT` or `Type.ATTRIBUTE`. There are seven kinds of node: documents, elements, attributes, text, comments, processing-instructions, and namespaces.
      Returns:
        an integer identifying the kind of node. These integer values are the same as those used in the DOM
      Since:
        8.4
      See Also:
        `Type`

    - #### isSameNodeInfo

          default boolean isSameNodeInfo​(NodeInfo other)

      Determine whether this is the same node as another node.

      Note that two different NodeInfo instances can represent the same conceptual node. Therefore the "==" operator should not be used to test node identity. The equals() method should give the same result as isSameNodeInfo(), but since this rule was introduced late it might not apply to all implementations.

      Note: a.isSameNodeInfo(b) if and only if generateId(a)==generateId(b).

      This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.

      From Saxon 9.9 this method has a default implementation that invokes `equals()`, and all Saxon implementations of `NodeInfo` rely on this default implementation. The method is retained for backwards compatibility, but applications are advised to use the `equals()` method in preference, and user-defined implementations of `NodeInfo` are advised to rely on the default implementation. In particular, implementations of `equals()` should not invoke `isSameNodeInfo`.

      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree. The default implementation returns `equals(other)`

    - #### equals

          boolean equals​(java.lang.Object other)

      The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
      Since:
        8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

    - #### hashCode

          int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Overrides:
        `hashCode` in class `java.lang.Object`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getSystemId

          java.lang.String getSystemId()

      Get the System ID for the node. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot. The base URI is used primarily for resolving relative URIs within the content of the document. The system ID is used primarily in conjunction with a line number, for identifying the location of elements within the source XML, in particular when errors are found. For a document node, the System ID represents the value of the document-uri property as defined in the XDM data model.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.
      Since:
        8.4

    - #### getPublicId

          default java.lang.String getPublicId()

      Get the Public ID of the entity containing the node. This method is provided largely so that NodeInfo can act as a `Locator` or `SourceLocator`, and many implementations return null.
      Specified by:
        `getPublicId` in interface `Location`
      Specified by:
        `getPublicId` in interface `org.xml.sax.Locator`
      Specified by:
        `getPublicId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the Public Identifier of the entity in the source document containing the node, or null if not known or not applicable. The default implementation returns null.
      Since:
        9.7

    - #### getBaseURI

          java.lang.String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used. Where the node does not have a base URI of its own, the base URI of its parent node is returned.
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.
      Since:
        8.4

    - #### getLineNumber

          default int getLineNumber()

      Get line number. Line numbers are not maintained by default, except for stylesheets and schema documents. Line numbering can be requested using the -l option on the command line, or by setting options on the TransformerFactory or the Configuration before the source document is built.

      The granularity of line numbering is normally the element level: for other nodes such as text nodes and attributes, the line number of the parent element will normally be returned.

      In the case of a tree constructed by taking input from a SAX parser, the line number will reflect the SAX rules: that is, the line number of an element is the line number where the start tag ends. This may be a little confusing where elements have many attributes spread over multiple lines, or where single attributes (as can easily happen with XSLT 2.0 stylesheets) occupy several lines.

      In the case of a tree constructed by a stylesheet or query, the line number may reflect the line in the stylesheet or query that caused the node to be constructed.

      The line number can be read from within an XPath expression using the Saxon extension function saxon:line-number()

      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number of the node in its original source document; or -1 if not available. The default implementation returns -1.
      Since:
        8.4

    - #### getColumnNumber

          default int getColumnNumber()

      Get column number. Column numbers are not maintained by default. Column numbering can be requested in the same way as line numbering; but a tree implementation can ignore the request.

      The granularity of column numbering is normally the element level: for other nodes such as text nodes and attributes, the line number of the parent element will normally be returned.

      In the case of a tree constructed by taking input from a SAX parser, the column number will reflect the SAX rules: that is, the column number of an element is the column number where the start tag ends. This may be a little confusing where elements have many attributes spread over multiple lines, or where single attributes (as can easily happen with XSLT 2.0 stylesheets) occupy several lines.

      In the case of a tree constructed by a stylesheet or query, the column number may reflect the line in the stylesheet or query that caused the node to be constructed.

      The column number can be read from within an XPath expression using the Saxon extension function saxon:column-number()

      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the column number of the node in its original source document; or -1 if not available. The default implementation returns -1.
      Since:
        9.1

    - #### compareOrder

          int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order.

      The other node must always be in the same tree; the effect of calling this method when the two nodes are in different trees is undefined. To obtain a global ordering of nodes, the application should first compare the result of getDocumentNumber(), and only if the document number is the same should compareOrder() be called.

      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())
      Since:
        8.4

    - #### getStringValue

          java.lang.String getStringValue()

      Return the string value of the node as defined in the XPath data model.

      The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.

      This method returns the string value as if the node were untyped. Unlike the string value accessor in the XPath 2.0 data model, it does not report an error if the element has a complex type, instead it returns the concatenation of the descendant text nodes as it would if the element were untyped.

      Specified by:
        `getStringValue` in interface `GroundedValue`
      Specified by:
        `getStringValue` in interface `Item`
      Returns:
        the string value of the node
      Since:
        8.4
      See Also:
        `Item.getStringValueCS()`

    - #### hasFingerprint

          boolean hasFingerprint()

      Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool. If the answer is true, then the `getFingerprint()` method must return the fingerprint of the node. If the answer is false, then the `getFingerprint()` method should throw an `UnsupportedOperationException`. In the case of unnamed nodes such as text nodes, the result can be either true (in which case getFingerprint() should return -1) or false (in which case getFingerprint may throw an exception).
      Returns:
        true if the implementation of this node provides fingerprints.
      Since:
        9.8; previously Saxon relied on using `FingerprintedNode` as a marker interface.

    - #### getFingerprint

          int getFingerprint()

      Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. The fingerprint contains no information about the namespace prefix. For a name in the null namespace, the fingerprint is the same as the name code.
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
      Throws:
        `java.lang.UnsupportedOperationException` - if this kind of node does not hold namepool fingerprints (specifically, if `hasFingerprint()` returns false).
      Since:
        8.4 (moved into FingerprintedNode at 9.7; then back into NodeInfo at 9.8).

    - #### getLocalPart

          java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Returns:
        the local part of the name. For an unnamed node, returns "". Unlike the DOM interface, this returns the full name in the case of a non-namespaced name.
      Since:
        8.4

    - #### getURI

          java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for an element or attribute that is not in a namespace, or for a processing instruction, returns an empty string.
      Since:
        8.4

    - #### getDisplayName

          java.lang.String getDisplayName()

      Get the display name of this node, in the form of a lexical QName. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Returns:
        The display name of this node. For a node with no name, returns an empty string.
      Since:
        8.4

    - #### getPrefix

          java.lang.String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, returns a zero-length string.
      Returns:
        The prefix of the name of the node.
      Since:
        8.4

    - #### getSchemaType

          default SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.

        The default implementation returns `BuiltInAtomicType.UNTYPED_ATOMIC` for attribute nodes, `Untyped.getInstance()` for element and document nodes, and null otherwise

      Since:
        9.4

    - #### atomize

          AtomicSequence atomize()
                          throws XPathException

      Get the typed value. This will either be a single AtomicValue or a value whose items are atomic values.
      Specified by:
        `atomize` in interface `Item`
      Returns:
        the typed value of the node
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
      Since:
        8.5. Changed in 9.5 to return the new type AtomicSequence.

    - #### getParent

          NodeInfo getParent()

      Get the NodeInfo object representing the parent of this node
      Returns:
        the parent of this node; null if this node has no parent
      Since:
        8.4

    - #### iterateAxis

          default AxisIterator iterateAxis​(int axisNumber)

      Return an iteration over all the nodes reached by the given axis from this node
      Parameters:
        `axisNumber` - an integer identifying the axis; one of the constants defined in class `AxisInfo`
      Returns:
        an AxisIterator that delivers the nodes reached by the axis in turn. The nodes are returned in axis order (document order for a forwards axis, reverse document order for a reverse axis). The default implementation returns `iterateAxis(axisNumber, AnyNodeTest.getInstance()`.
      Throws:
        `java.lang.UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
      Since:
        8.4
      See Also:
        `AxisInfo`

    - #### iterateAxis

          AxisIterator iterateAxis​(int axisNumber,
                                   java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
      Parameters:
        `axisNumber` - an integer identifying the axis; one of the constants defined in class `AxisInfo`
        `nodeTest` - A condition to be satisfied by the returned nodes; nodes that do not satisfy this condition are not included in the result
      Returns:
        an AxisIterator that delivers the nodes reached by the axis in turn. The nodes are returned in axis order (document order for a forwards axis, reverse document order for a reverse axis).
      Throws:
        `java.lang.UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
      Since:
        8.4. Changed in 10.0 to accept any `Predicate<NodeInfo>` as the second argument. It is still possible to supply an `NodeTest`, because `NodeTest` implements `Predicate<NodeInfo>`.
      See Also:
        `AxisInfo`

    - #### getAttributeValue

          java.lang.String getAttributeValue​(java.lang.String uri,
                                             java.lang.String local)

      Get the string value of a given attribute of this node
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          NodeInfo getRoot()

      Get the root node of the tree containing this node
      Returns:
        the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node. If this node has no parent, then the method returns this node.
      Since:
        8.4

    - #### hasChildNodes

          boolean hasChildNodes()

      Determine whether the node has any children.

      Note: the result is equivalent to `iterateAxis(Axis.CHILD).next() != null`

      Returns:
        True if the node has one or more children
      Since:
        8.4

    - #### children

          default java.lang.Iterable<? extends NodeInfo> children()

      Return the sequence of children of this node, as an `Iterable`. This method is designed to allow iteration over the children in a Java "for each" loop, in the form `for (NodeInfo child : children()) {...}`
      Returns:
        the children of the node, as an `Iterable`.

    - #### children

          default java.lang.Iterable<? extends NodeInfo> children​(java.util.function.Predicate<? super NodeInfo> filter)

      Return the sequence of children of this node, filtered by a supplied predicate, as an `Iterable`.
      Parameters:
        `filter` - a condition that the selected children must satisfy
      Returns:
        the children of the node, as an `Iterable`.

    - #### attributes

          default AttributeMap attributes()

    - #### generateId

          void generateId​(FastStringBuffer buffer)

      Construct a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Parameters:
        `buffer` - a buffer which will be updated to hold a string that uniquely identifies this node, across all documents.
      Since:
        8.7

        Changed in Saxon 8.7 to generate the ID value in a client-supplied buffer

    - #### copy

          default void copy​(Receiver out,
                            int copyOptions,
                            Location locationId)
                     throws XPathException

      Copy this node to a given Receiver.

      This method is primarily for internal use. It should not be considered a stable part of the Saxon API.

      The default implementation invokes `Navigator.copy(this, out, copyOptions, locationId);` which is always adequate.

      Parameters:
        `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
        `copyOptions` - a selection of the options defined in `CopyOptions`
        `locationId` - If non-null, identifies the location of the instruction that requested this copy. If zero, indicates that the location information is not available
      Throws:
        `XPathException` - if any downstream error occurs
        `java.lang.IllegalArgumentException` - if the node is an attribute or namespace node

    - #### getDeclaredNamespaces

          NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace declarations and undeclarations defined on this element.

      This method is intended primarily for internal use. User applications needing information about the namespace context of a node should use `iterateAxis(Axis.NAMESPACE)`. (However, not all implementations support the namespace axis, whereas all implementations are required to support this method.)

      In many cases (and in particular with Saxon's TinyTree and LinkedTree implementations), from 10.0 onwards it is more efficient to call `getAllNamespaces()` to get all the in-scope namespaces at once, rather than building up the list be calling `getDeclaredNamespaces` on each ancestor node.

      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of namespace binding objects representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. If the uri part is "", then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to null.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). The map does NOT include the implicit binding of the XML namespace. It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### isId

          default boolean isId()

      Ask whether this node has the is-id property
      Returns:
        true if the node is an ID. The default implementation returns false.

    - #### isIdref

          default boolean isIdref()

      Ask whether this node has the is-idref property
      Returns:
        true if the node is an IDREF or IDREFS element or attribute. The default implementation returns false.

    - #### isNilled

          default boolean isNilled()

      Ask whether the node has the is-nilled property
      Returns:
        true if the node has the is-nilled property. The default implementation returns false.

    - #### isStreamed

          default boolean isStreamed()

      Ask whether this is a node in a streamed document
      Specified by:
        `isStreamed` in interface `Item`
      Returns:
        true if the node is in a document being processed using streaming. The default implementation returns false.

    - #### toShortString

          default java.lang.String toShortString()

      Provide a short string showing the contents of the item, suitable for use in error messages
      Specified by:
        `toShortString` in interface `GroundedValue`
      Specified by:
        `toShortString` in interface `Item`
      Returns:
        a depiction of the item suitable for use in error messages. The default implementation returns:
        - `document-node()` for a document node
        - `<p:local/>` for an element node
        - `@p:local` for an attribute node
        - `text("In a hole...")` for a text node
        - `<--You are old, ...-->` for a comment node
        - `<?pi?>` for a processing instruction node
        - `xmlns:p=uri` for a namespace node

    - #### getGenre

          default Genre getGenre()

      Get the genre of this item
      Specified by:
        `getGenre` in interface `Item`
      Returns:
        the genre: specifically, `Genre.NODE`. The default implementation (which should not be overridden) returns `Genre.NODE`.